Index: wp-includes/class-wp-xmlrpc-server.php
===================================================================
--- wp-includes/class-wp-xmlrpc-server.php	(revision 23401)
+++ wp-includes/class-wp-xmlrpc-server.php	(working copy)
@@ -280,17 +280,15 @@
 				$meta['id'] = (int) $meta['id'];
 				$pmeta = get_metadata_by_mid( 'post', $meta['id'] );
 				if ( isset($meta['key']) ) {
-					$meta['key'] = stripslashes( $meta['key'] );
 					if ( $meta['key'] != $pmeta->meta_key )
 						continue;
-					$meta['value'] = stripslashes_deep( $meta['value'] );
 					if ( current_user_can( 'edit_post_meta', $post_id, $meta['key'] ) )
 						update_metadata_by_mid( 'post', $meta['id'], $meta['value'] );
 				} elseif ( current_user_can( 'delete_post_meta', $post_id, $pmeta->meta_key ) ) {
 					delete_metadata_by_mid( 'post', $meta['id'] );
 				}
-			} elseif ( current_user_can( 'add_post_meta', $post_id, stripslashes( $meta['key'] ) ) ) {
-				add_post_meta( $post_id, $meta['key'], $meta['value'] );
+			} elseif ( current_user_can( 'add_post_meta', $post_id, $meta['key'] ) ) {
+				wp_add_post_meta( $post_id, $meta['key'], $meta['value'] );
 			}
 		}
 	}
@@ -462,8 +460,6 @@
 			return $this->blogger_getUsersBlogs( $args );
 		}
 
-		$this->escape( $args );
-
 		$username = $args[0];
 		$password = $args[1];
 
@@ -955,8 +951,6 @@
 		if ( ! $this->minimum_args( $args, 4 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id        = (int) $args[0];
 		$username       = $args[1];
 		$password       = $args[2];
@@ -1239,8 +1233,6 @@
 		if ( ! $this->minimum_args( $args, 5 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id        = (int) $args[0];
 		$username       = $args[1];
 		$password       = $args[2];
@@ -1274,7 +1266,6 @@
 		else
 			$post['post_date_gmt'] = $this->_convert_date( $post['post_date_gmt'] );
 
-		$this->escape( $post );
 		$merged_content_struct = array_merge( $post, $content_struct );
 
 		$retval = $this->_insert_post( $user, $merged_content_struct );
@@ -1301,8 +1292,6 @@
 		if ( ! $this->minimum_args( $args, 4 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id    = (int) $args[0];
 		$username   = $args[1];
 		$password   = $args[2];
@@ -1377,8 +1366,6 @@
 		if ( ! $this->minimum_args( $args, 4 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id            = (int) $args[0];
 		$username           = $args[1];
 		$password           = $args[2];
@@ -1434,8 +1421,6 @@
 		if ( ! $this->minimum_args( $args, 3 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id    = (int) $args[0];
 		$username   = $args[1];
 		$password   = $args[2];
@@ -1529,8 +1514,6 @@
 		if ( ! $this->minimum_args( $args, 4 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id            = (int) $args[0];
 		$username           = $args[1];
 		$password           = $args[2];
@@ -1616,8 +1599,6 @@
 		if ( ! $this->minimum_args( $args, 5 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id            = (int) $args[0];
 		$username           = $args[1];
 		$password           = $args[2];
@@ -1708,8 +1689,6 @@
 		if ( ! $this->minimum_args( $args, 5 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id            = (int) $args[0];
 		$username           = $args[1];
 		$password           = $args[2];
@@ -1775,8 +1754,6 @@
 		if ( ! $this->minimum_args( $args, 5 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id            = (int) $args[0];
 		$username           = $args[1];
 		$password           = $args[2];
@@ -1828,8 +1805,6 @@
 		if ( ! $this->minimum_args( $args, 4 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id        = (int) $args[0];
 		$username       = $args[1];
 		$password       = $args[2];
@@ -1903,8 +1878,6 @@
 		if ( ! $this->minimum_args( $args, 4 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id        = (int) $args[0];
 		$username       = $args[1];
 		$password       = $args[2];
@@ -1947,8 +1920,6 @@
 		if ( ! $this->minimum_args( $args, 3 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id            = (int) $args[0];
 		$username           = $args[1];
 		$password           = $args[2];
@@ -2016,8 +1987,6 @@
 		if ( ! $this->minimum_args( $args, 4 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id    = (int) $args[0];
 		$username   = $args[1];
 		$password   = $args[2];
@@ -2069,8 +2038,6 @@
 		if ( ! $this->minimum_args( $args, 3 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id    = (int) $args[0];
 		$username   = $args[1];
 		$password   = $args[2];
@@ -2137,8 +2104,6 @@
 		if ( ! $this->minimum_args( $args, 3 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id    = (int) $args[0];
 		$username   = $args[1];
 		$password   = $args[2];
@@ -2184,8 +2149,6 @@
 		if ( ! $this->minimum_args( $args, 4 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id        = (int) $args[0];
 		$username       = $args[1];
 		$password       = $args[2];
@@ -2249,8 +2212,6 @@
 	 * @return array
 	 */
 	function wp_getPage($args) {
-		$this->escape($args);
-
 		$blog_id	= (int) $args[0];
 		$page_id	= (int) $args[1];
 		$username	= $args[2];
@@ -2292,8 +2253,6 @@
 	 * @return array
 	 */
 	function wp_getPages($args) {
-		$this->escape($args);
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -2336,9 +2295,8 @@
 	 * @return unknown
 	 */
 	function wp_newPage($args) {
-		// Items not escaped here will be escaped in newPost.
-		$username	= $this->escape($args[1]);
-		$password	= $this->escape($args[2]);
+		$username	= $args[1];
+		$password	= $args[2];
 		$page		= $args[3];
 		$publish	= $args[4];
 
@@ -2363,8 +2321,6 @@
 	 * @return bool True, if success.
 	 */
 	function wp_deletePage($args) {
-		$this->escape($args);
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -2404,11 +2360,10 @@
 	 * @return unknown
 	 */
 	function wp_editPage($args) {
-		// Items not escaped here will be escaped in editPost.
 		$blog_id	= (int) $args[0];
-		$page_id	= (int) $this->escape($args[1]);
-		$username	= $this->escape($args[2]);
-		$password	= $this->escape($args[3]);
+		$page_id	= (int) $args[1];
+		$username	= $args[2];
+		$password	= $args[3];
 		$content	= $args[4];
 		$publish	= $args[5];
 
@@ -2453,8 +2408,6 @@
 	function wp_getPageList($args) {
 		global $wpdb;
 
-		$this->escape($args);
-
 		$blog_id				= (int) $args[0];
 		$username				= $args[1];
 		$password				= $args[2];
@@ -2503,9 +2456,6 @@
 	 * @return array
 	 */
 	function wp_getAuthors($args) {
-
-		$this->escape($args);
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -2539,8 +2489,6 @@
 	 * @return array
 	 */
 	function wp_getTags( $args ) {
-		$this->escape( $args );
-
 		$blog_id		= (int) $args[0];
 		$username		= $args[1];
 		$password		= $args[2];
@@ -2580,8 +2528,6 @@
 	 * @return int Category ID.
 	 */
 	function wp_newCategory($args) {
-		$this->escape($args);
-
 		$blog_id				= (int) $args[0];
 		$username				= $args[1];
 		$password				= $args[2];
@@ -2641,8 +2587,6 @@
 	 * @return mixed See {@link wp_delete_term()} for return info.
 	 */
 	function wp_deleteCategory($args) {
-		$this->escape($args);
-
 		$blog_id		= (int) $args[0];
 		$username		= $args[1];
 		$password		= $args[2];
@@ -2673,8 +2617,6 @@
 	 * @return array
 	 */
 	function wp_suggestCategories($args) {
-		$this->escape($args);
-
 		$blog_id				= (int) $args[0];
 		$username				= $args[1];
 		$password				= $args[2];
@@ -2710,8 +2652,6 @@
 	 * @return array
 	 */
 	function wp_getComment($args) {
-		$this->escape($args);
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -2751,8 +2691,6 @@
 	 * @return array. Contains a collection of comments. See {@link wp_xmlrpc_server::wp_getComment()} for a description of each item contents
 	 */
 	function wp_getComments($args) {
-		$this->escape($args);
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -2811,8 +2749,6 @@
 	 * @return mixed {@link wp_delete_comment()}
 	 */
 	function wp_deleteComment($args) {
-		$this->escape($args);
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -2865,8 +2801,6 @@
 	 * @return bool True, on success.
 	 */
 	function wp_editComment($args) {
-		$this->escape($args);
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -2942,8 +2876,6 @@
 	function wp_newComment($args) {
 		global $wpdb;
 
-		$this->escape($args);
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -2978,9 +2910,9 @@
 		$comment['comment_post_ID'] = $post_id;
 
 		if ( $logged_in ) {
-			$comment['comment_author'] = $wpdb->escape( $user->display_name );
-			$comment['comment_author_email'] = $wpdb->escape( $user->user_email );
-			$comment['comment_author_url'] = $wpdb->escape( $user->user_url );
+			$comment['comment_author'] = $user->display_name;
+			$comment['comment_author_email'] = $user->user_email;
+			$comment['comment_author_url'] = $user->user_url;
 			$comment['user_ID'] = $user->ID;
 		} else {
 			$comment['comment_author'] = '';
@@ -3027,8 +2959,6 @@
 	 * @return array
 	 */
 	function wp_getCommentStatusList($args) {
-		$this->escape( $args );
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -3053,8 +2983,6 @@
 	 * @return array
 	 */
 	function wp_getCommentCount( $args ) {
-		$this->escape($args);
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -3086,8 +3014,6 @@
 	 * @return array
 	 */
 	function wp_getPostStatusList( $args ) {
-		$this->escape( $args );
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -3112,8 +3038,6 @@
 	 * @return array
 	 */
 	function wp_getPageStatusList( $args ) {
-		$this->escape( $args );
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -3138,8 +3062,6 @@
 	 * @return array
 	 */
 	function wp_getPageTemplates( $args ) {
-		$this->escape( $args );
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -3165,8 +3087,6 @@
 	 * @return array
 	 */
 	function wp_getOptions( $args ) {
-		$this->escape( $args );
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -3215,8 +3135,6 @@
 	 * @return unknown
 	 */
 	function wp_setOptions( $args ) {
-		$this->escape( $args );
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -3264,8 +3182,6 @@
 	 *  - 'metadata'
 	 */
 	function wp_getMediaItem($args) {
-		$this->escape($args);
-
 		$blog_id		= (int) $args[0];
 		$username		= $args[1];
 		$password		= $args[2];
@@ -3309,8 +3225,6 @@
 	 * @return array. Contains a collection of media items. See {@link wp_xmlrpc_server::wp_getMediaItem()} for a description of each item contents
 	 */
 	function wp_getMediaLibrary($args) {
-		$this->escape($args);
-
 		$blog_id	= (int) $args[0];
 		$username	= $args[1];
 		$password	= $args[2];
@@ -3351,8 +3265,6 @@
 	  * @return array
 	  */
 	function wp_getPostFormats( $args ) {
-		$this->escape( $args );
-
 		$blog_id = (int) $args[0];
 		$username = $args[1];
 		$password = $args[2];
@@ -3411,8 +3323,6 @@
 		if ( ! $this->minimum_args( $args, 4 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id        = (int) $args[0];
 		$username       = $args[1];
 		$password       = $args[2];
@@ -3457,8 +3367,6 @@
 		if ( ! $this->minimum_args( $args, 3 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id            = (int) $args[0];
 		$username           = $args[1];
 		$password           = $args[2];
@@ -3511,8 +3419,6 @@
 		if ( ! $this->minimum_args( $args, 4 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id    = (int) $args[0];
 		$username   = $args[1];
 		$password   = $args[2];
@@ -3577,8 +3483,6 @@
 		if ( ! $this->minimum_args( $args, 3 ) )
 			return $this->error;
 
-		$this->escape( $args );
-
 		$blog_id     = (int) $args[0];
 		$username    = $args[1];
 		$password    = $args[2];
@@ -3628,8 +3532,6 @@
 		if ( is_multisite() )
 			return $this->_multisite_getUsersBlogs($args);
 
-		$this->escape($args);
-
 		$username = $args[1];
 		$password  = $args[2];
 
@@ -3691,9 +3593,6 @@
 	 * @return array
 	 */
 	function blogger_getUserInfo($args) {
-
-		$this->escape($args);
-
 		$username = $args[1];
 		$password  = $args[2];
 
@@ -3725,9 +3624,6 @@
 	 * @return array
 	 */
 	function blogger_getPost($args) {
-
-		$this->escape($args);
-
 		$post_ID    = (int) $args[1];
 		$username = $args[2];
 		$password  = $args[3];
@@ -3746,9 +3642,9 @@
 
 		$categories = implode(',', wp_get_post_categories($post_ID));
 
-		$content  = '<title>'.stripslashes($post_data['post_title']).'</title>';
+		$content  = '<title>'.$post_data['post_title'].'</title>';
 		$content .= '<category>'.$categories.'</category>';
-		$content .= stripslashes($post_data['post_content']);
+		$content .= $post_data['post_content'];
 
 		$struct = array(
 			'userid'      => (string) $post_data['post_author'],
@@ -3769,9 +3665,6 @@
 	 * @return array
 	 */
 	function blogger_getRecentPosts($args) {
-
-		$this->escape($args);
-
 		// $args[0] = appkey - ignored
 		$blog_ID    = (int) $args[1]; /* though we don't use it yet */
 		$username = $args[2];
@@ -3800,9 +3693,9 @@
 			$post_date  = $this->_convert_date( $entry['post_date'] );
 			$categories = implode(',', wp_get_post_categories($entry['ID']));
 
-			$content  = '<title>'.stripslashes($entry['post_title']).'</title>';
+			$content  = '<title>'.$entry['post_title'].'</title>';
 			$content .= '<category>'.$categories.'</category>';
-			$content .= stripslashes($entry['post_content']);
+			$content .= $entry['post_content'];
 
 			$struct[] = array(
 				'userid'      => (string) $entry['post_author'],
@@ -3850,9 +3743,6 @@
 	 * @return int
 	 */
 	function blogger_newPost($args) {
-
-		$this->escape($args);
-
 		$blog_ID    = (int) $args[1]; /* though we don't use it yet */
 		$username = $args[2];
 		$password  = $args[3];
@@ -3904,9 +3794,6 @@
 	 * @return bool true when done.
 	 */
 	function blogger_editPost($args) {
-
-		$this->escape($args);
-
 		$post_ID     = (int) $args[1];
 		$username  = $args[2];
 		$password   = $args[3];
@@ -3923,8 +3810,6 @@
 		if ( !$actual_post || $actual_post['post_type'] != 'post' )
 			return new IXR_Error(404, __('Sorry, no such post.'));
 
-		$this->escape($actual_post);
-
 		if ( !current_user_can('edit_post', $post_ID) )
 			return new IXR_Error(401, __('Sorry, you do not have the right to edit this post.'));
 
@@ -3960,8 +3845,6 @@
 	 * @return bool True when post is deleted.
 	 */
 	function blogger_deletePost($args) {
-		$this->escape($args);
-
 		$post_ID     = (int) $args[1];
 		$username  = $args[2];
 		$password   = $args[3];
@@ -4030,13 +3913,11 @@
 	 * @return int
 	 */
 	function mw_newPost($args) {
-		$this->escape($args);
-
-		$blog_ID     = (int) $args[0];
-		$username  = $args[1];
-		$password   = $args[2];
+		$blog_ID        = (int) $args[0];
+		$username       = $args[1];
+		$password       = $args[2];
 		$content_struct = $args[3];
-		$publish     = isset( $args[4] ) ? $args[4] : 0;
+		$publish        = isset( $args[4] ) ? $args[4] : 0;
 
 		if ( !$user = $this->login($username, $password) )
 			return $this->error;
@@ -4316,7 +4197,7 @@
 				}
 			}
 			if (!$found)
-				add_post_meta( $post_ID, 'enclosure', $encstring );
+				wp_add_post_meta( $post_ID, 'enclosure', $encstring );
 		}
 	}
 
@@ -4350,9 +4231,6 @@
 	 * @return bool True on success.
 	 */
 	function mw_editPost($args) {
-
-		$this->escape($args);
-
 		$post_ID        = (int) $args[0];
 		$username       = $args[1];
 		$password       = $args[2];
@@ -4391,7 +4269,6 @@
 			}
 		}
 
-		$this->escape($postdata);
 		extract($postdata, EXTR_SKIP);
 
 		// Let WordPress manage slug if none was provided.
@@ -4619,9 +4496,6 @@
 	 * @return array
 	 */
 	function mw_getPost($args) {
-
-		$this->escape($args);
-
 		$post_ID     = (int) $args[0];
 		$username  = $args[1];
 		$password   = $args[2];
@@ -4743,9 +4617,6 @@
 	 * @return array
 	 */
 	function mw_getRecentPosts($args) {
-
-		$this->escape($args);
-
 		$blog_ID     = (int) $args[0];
 		$username  = $args[1];
 		$password   = $args[2];
@@ -4858,9 +4729,6 @@
 	 * @return array
 	 */
 	function mw_getCategories($args) {
-
-		$this->escape($args);
-
 		$blog_ID     = (int) $args[0];
 		$username  = $args[1];
 		$password   = $args[2];
@@ -4907,10 +4775,10 @@
 	function mw_newMediaObject($args) {
 		global $wpdb;
 
-		$blog_ID     = (int) $args[0];
-		$username  = $wpdb->escape($args[1]);
-		$password   = $wpdb->escape($args[2]);
-		$data        = $args[3];
+		$blog_ID   = (int) $args[0];
+		$username  = $args[1];
+		$password  = $args[2];
+		$data      = $args[3];
 
 		$name = sanitize_file_name( $data['name'] );
 		$type = $data['type'];
@@ -4997,9 +4865,6 @@
 	 * @return array
 	 */
 	function mt_getRecentPostTitles($args) {
-
-		$this->escape($args);
-
 		$blog_ID     = (int) $args[0];
 		$username  = $args[1];
 		$password   = $args[2];
@@ -5057,9 +4922,6 @@
 	 * @return array
 	 */
 	function mt_getCategoryList($args) {
-
-		$this->escape($args);
-
 		$blog_ID     = (int) $args[0];
 		$username  = $args[1];
 		$password   = $args[2];
@@ -5095,9 +4957,6 @@
 	 * @return array
 	 */
 	function mt_getPostCategories($args) {
-
-		$this->escape($args);
-
 		$post_ID     = (int) $args[0];
 		$username  = $args[1];
 		$password   = $args[2];
@@ -5138,9 +4997,6 @@
 	 * @return bool True on success.
 	 */
 	function mt_setPostCategories($args) {
-
-		$this->escape($args);
-
 		$post_ID     = (int) $args[0];
 		$username  = $args[1];
 		$password   = $args[2];
@@ -5250,9 +5106,6 @@
 	 * @return int
 	 */
 	function mt_publishPost($args) {
-
-		$this->escape($args);
-
 		$post_ID     = (int) $args[0];
 		$username  = $args[1];
 		$password   = $args[2];
@@ -5274,7 +5127,6 @@
 		// retain old cats
 		$cats = wp_get_post_categories($post_ID);
 		$postdata['post_category'] = $cats;
-		$this->escape($postdata);
 
 		$result = wp_update_post($postdata);
 
@@ -5298,8 +5150,6 @@
 
 		do_action('xmlrpc_call', 'pingback.ping');
 
-		$this->escape($args);
-
 		$pagelinkedfrom = $args[0];
 		$pagelinkedto   = $args[1];
 
@@ -5435,15 +5285,15 @@
 		$pagelinkedfrom = str_replace('&', '&amp;', $pagelinkedfrom);
 
 		$context = '[...] ' . esc_html( $excerpt ) . ' [...]';
-		$pagelinkedfrom = $wpdb->escape( $pagelinkedfrom );
+		$pagelinkedfrom = $pagelinkedfrom;
 
 		$comment_post_ID = (int) $post_ID;
 		$comment_author = $title;
 		$comment_author_email = '';
-		$this->escape($comment_author);
+		$comment_author;
 		$comment_author_url = $pagelinkedfrom;
 		$comment_content = $context;
-		$this->escape($comment_content);
+		$comment_content;
 		$comment_type = 'pingback';
 
 		$commentdata = compact('comment_post_ID', 'comment_author', 'comment_author_url', 'comment_author_email', 'comment_content', 'comment_type');
@@ -5465,13 +5315,10 @@
 	 * @return array
 	 */
 	function pingback_extensions_getPingbacks($args) {
-
 		global $wpdb;
 
 		do_action('xmlrpc_call', 'pingback.extensions.getPingbacks');
 
-		$this->escape($args);
-
 		$url = $args;
 
 		$post_ID = url_to_postid($url);
Index: wp-includes/query.php
===================================================================
--- wp-includes/query.php	(revision 23401)
+++ wp-includes/query.php	(working copy)
@@ -1733,7 +1733,6 @@
 		// Category stuff
 		if ( !empty($q['cat']) && '0' != $q['cat'] && !$this->is_singular && $this->query_vars_changed ) {
 			$q['cat'] = ''.urldecode($q['cat']).'';
-			$q['cat'] = addslashes_gpc($q['cat']);
 			$cat_array = preg_split('/[,\s]+/', $q['cat']);
 			$q['cat'] = '';
 			$req_cats = array();
@@ -2180,8 +2179,6 @@
 
 		// If a search pattern is specified, load the posts that match
 		if ( !empty($q['s']) ) {
-			// added slashes screw with quote grouping when done early, so done later
-			$q['s'] = stripslashes($q['s']);
 			if ( empty( $_GET['s'] ) && $this->is_main_query() )
 				$q['s'] = urldecode($q['s']);
 			if ( !empty($q['sentence']) ) {
@@ -2290,7 +2287,6 @@
 			$whichauthor = '';
 		} else {
 			$q['author'] = (string)urldecode($q['author']);
-			$q['author'] = addslashes_gpc($q['author']);
 			if ( strpos($q['author'], '-') !== false ) {
 				$eq = '!=';
 				$andor = 'AND';
@@ -2352,7 +2348,6 @@
 				$allowed_keys[] = 'meta_value_num';
 			}
 			$q['orderby'] = urldecode($q['orderby']);
-			$q['orderby'] = addslashes_gpc($q['orderby']);
 
 			$orderby_array = array();
 			foreach ( explode( ' ', $q['orderby'] ) as $i => $orderby ) {
Index: wp-includes/link-template.php
===================================================================
--- wp-includes/link-template.php	(revision 23401)
+++ wp-includes/link-template.php	(working copy)
@@ -746,7 +746,7 @@
 	if ( empty($query) )
 		$search = get_search_query( false );
 	else
-		$search = stripslashes($query);
+		$search = $query;
 
 	$permastruct = $wp_rewrite->get_search_permastruct();
 
Index: wp-includes/formatting.php
===================================================================
--- wp-includes/formatting.php	(revision 23401)
+++ wp-includes/formatting.php	(working copy)
@@ -1716,10 +1716,7 @@
  * @return string Converted content.
  */
 function wp_rel_nofollow( $text ) {
-	// This is a pre save filter, so text is already escaped.
-	$text = stripslashes($text);
 	$text = preg_replace_callback('|<a (.+?)>|i', 'wp_rel_nofollow_callback', $text);
-	$text = esc_sql($text);
 	return $text;
 }
 
@@ -3342,3 +3339,37 @@
 	$urls_to_ping = implode( "\n", $urls_to_ping );
 	return apply_filters( 'sanitize_trackback_urls', $urls_to_ping, $to_ping );
 }
+
+/**
+ * Slash a string or array of strings.
+ *
+ * This should be used only for GPC data.
+ *
+ * @since 3.6.0
+ *
+ * @param string|array $value String or array of strings to slash.
+ * @return string|array Slashed $value
+ */
+function wp_slash( $value ) {
+	if ( is_array( $value ) ) { 
+		array_map( 'wp_slash', $value); 
+	} else { 
+		$value = addslashes( $value ); 
+	} 
+
+	return $value; 
+}
+
+/**
+ * Remove slashes a string or array of strings.
+ *
+ * This should be used for GPC data before passing it along to core API.
+ *
+ * @since 3.6.0
+ *
+ * @param string|array $value String or array of strings to unslash.
+ * @return string|array Unslashed $value
+ */
+function wp_unslash( $value ) {
+	return stripslashes_deep( $value ); 
+}
Index: wp-includes/class-wp.php
===================================================================
--- wp-includes/class-wp.php	(revision 23401)
+++ wp-includes/class-wp.php	(working copy)
@@ -142,15 +142,15 @@
 			$this->did_permalink = true;
 
 			if ( isset($_SERVER['PATH_INFO']) )
-				$pathinfo = $_SERVER['PATH_INFO'];
+				$pathinfo = wp_unslash( $_SERVER['PATH_INFO'] );
 			else
 				$pathinfo = '';
 			$pathinfo_array = explode('?', $pathinfo);
 			$pathinfo = str_replace("%", "%25", $pathinfo_array[0]);
-			$req_uri = $_SERVER['REQUEST_URI'];
+			$req_uri = wp_unslash( $_SERVER['REQUEST_URI'] );
 			$req_uri_array = explode('?', $req_uri);
 			$req_uri = $req_uri_array[0];
-			$self = $_SERVER['PHP_SELF'];
+			$self = wp_unslash( $_SERVER['PHP_SELF'] );
 			$home_path = parse_url(home_url());
 			if ( isset($home_path['path']) )
 				$home_path = $home_path['path'];
@@ -255,9 +255,9 @@
 			if ( isset( $this->extra_query_vars[$wpvar] ) )
 				$this->query_vars[$wpvar] = $this->extra_query_vars[$wpvar];
 			elseif ( isset( $_POST[$wpvar] ) )
-				$this->query_vars[$wpvar] = $_POST[$wpvar];
+				$this->query_vars[$wpvar] = wp_unslash( $_POST[$wpvar] );
 			elseif ( isset( $_GET[$wpvar] ) )
-				$this->query_vars[$wpvar] = $_GET[$wpvar];
+				$this->query_vars[$wpvar] = wp_unslash( $_GET[$wpvar] );
 			elseif ( isset( $perma_query_vars[$wpvar] ) )
 				$this->query_vars[$wpvar] = $perma_query_vars[$wpvar];
 
@@ -356,7 +356,7 @@
 
 			// Support for Conditional GET
 			if (isset($_SERVER['HTTP_IF_NONE_MATCH']))
-				$client_etag = stripslashes(stripslashes($_SERVER['HTTP_IF_NONE_MATCH']));
+				$client_etag = stripslashes( wp_unslash( $_SERVER['HTTP_IF_NONE_MATCH'] ) ); // Retain extra strip. See #2597
 			else $client_etag = false;
 
 			$client_last_modified = empty($_SERVER['HTTP_IF_MODIFIED_SINCE']) ? '' : trim($_SERVER['HTTP_IF_MODIFIED_SINCE']);
Index: wp-includes/deprecated.php
===================================================================
--- wp-includes/deprecated.php	(revision 23401)
+++ wp-includes/deprecated.php	(working copy)
@@ -2383,7 +2383,7 @@
 
 	/** @todo Might need fix because usermeta data is assumed to be already escaped */
 	if ( is_string($meta_value) )
-		$meta_value = stripslashes($meta_value);
+		$meta_value = $meta_value;
 	$meta_value = maybe_serialize($meta_value);
 
 	if (empty($meta_value)) {
Index: wp-includes/cron.php
===================================================================
--- wp-includes/cron.php	(revision 23401)
+++ wp-includes/cron.php	(working copy)
@@ -230,7 +230,7 @@
 		set_transient( 'doing_cron', $doing_wp_cron );
 
 		ob_start();
-		wp_redirect( add_query_arg('doing_wp_cron', $doing_wp_cron, stripslashes($_SERVER['REQUEST_URI'])) );
+		wp_redirect( add_query_arg( 'doing_wp_cron', $doing_wp_cron, wp_unslash( $_SERVER['REQUEST_URI'] ) ) );
 		echo ' ';
 
 		// flush any buffers and send the headers
Index: wp-includes/pluggable.php
===================================================================
--- wp-includes/pluggable.php	(revision 23401)
+++ wp-includes/pluggable.php	(working copy)
@@ -782,7 +782,7 @@
 	// The cookie is no good so force login
 	nocache_headers();
 
-	$redirect = ( strpos( $_SERVER['REQUEST_URI'], '/options.php' ) && wp_get_referer() ) ? wp_get_referer() : set_url_scheme( 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'] );
+	$redirect = ( strpos( $_SERVER['REQUEST_URI'], '/options.php' ) && wp_get_referer() ) ? wp_get_referer() : set_url_scheme( 'http://' . wp_unslash( $_SERVER['HTTP_HOST'] ) . wp_unslash( $_SERVER['REQUEST_URI'] ) );
 
 	$login_url = wp_login_url($redirect, true);
 
@@ -1197,8 +1197,8 @@
 function wp_new_user_notification($user_id, $plaintext_pass = '') {
 	$user = get_userdata( $user_id );
 
-	$user_login = stripslashes($user->user_login);
-	$user_email = stripslashes($user->user_email);
+	$user_login = $user->user_login;
+	$user_email = $user->user_email;
 
 	// The blogname option is escaped with esc_html on the way into the database in sanitize_option
 	// we want to reverse this for the plain text arena of emails.
Index: wp-includes/feed.php
===================================================================
--- wp-includes/feed.php	(revision 23401)
+++ wp-includes/feed.php	(working copy)
@@ -488,7 +488,7 @@
  */
 function self_link() {
 	$host = @parse_url(home_url());
-	echo esc_url( set_url_scheme( 'http://' . $host['host'] . stripslashes($_SERVER['REQUEST_URI']) ) );
+	echo esc_url( set_url_scheme( 'http://' . $host['host'] . wp_unslash( $_SERVER['REQUEST_URI'] ) ) );
 }
 
 /**
Index: wp-includes/kses.php
===================================================================
--- wp-includes/kses.php	(revision 23401)
+++ wp-includes/kses.php	(working copy)
@@ -1326,18 +1326,18 @@
  */
 function kses_init_filters() {
 	// Normal filtering
-	add_filter('title_save_pre', 'wp_filter_kses');
+	add_filter('title_save_pre', 'wp_kses_data');
 
 	// Comment filtering
 	if ( current_user_can( 'unfiltered_html' ) )
-		add_filter( 'pre_comment_content', 'wp_filter_post_kses' );
+		add_filter( 'pre_comment_content', 'wp_kses_post' );
 	else
-		add_filter( 'pre_comment_content', 'wp_filter_kses' );
+		add_filter( 'pre_comment_content', 'wp_kses_data' );
 
 	// Post filtering
-	add_filter('content_save_pre', 'wp_filter_post_kses');
-	add_filter('excerpt_save_pre', 'wp_filter_post_kses');
-	add_filter('content_filtered_save_pre', 'wp_filter_post_kses');
+	add_filter('content_save_pre', 'wp_kses_post');
+	add_filter('excerpt_save_pre', 'wp_kses_post');
+	add_filter('content_filtered_save_pre', 'wp_kses_post');
 }
 
 /**
@@ -1354,16 +1354,16 @@
  */
 function kses_remove_filters() {
 	// Normal filtering
-	remove_filter('title_save_pre', 'wp_filter_kses');
+	remove_filter('title_save_pre', 'wp_kses_data');
 
 	// Comment filtering
-	remove_filter( 'pre_comment_content', 'wp_filter_post_kses' );
-	remove_filter( 'pre_comment_content', 'wp_filter_kses' );
+	remove_filter( 'pre_comment_content', 'wp_kses_post' );
+	remove_filter( 'pre_comment_content', 'wp_kses_data' );
 
 	// Post filtering
-	remove_filter('content_save_pre', 'wp_filter_post_kses');
-	remove_filter('excerpt_save_pre', 'wp_filter_post_kses');
-	remove_filter('content_filtered_save_pre', 'wp_filter_post_kses');
+	remove_filter('content_save_pre', 'wp_kses_post');
+	remove_filter('excerpt_save_pre', 'wp_kses_post');
+	remove_filter('content_filtered_save_pre', 'wp_kses_post');
 }
 
 /**
Index: wp-includes/widgets.php
===================================================================
--- wp-includes/widgets.php	(revision 23401)
+++ wp-includes/widgets.php	(working copy)
@@ -224,7 +224,7 @@
 			}
 
 			foreach ( $settings as $number => $new_instance ) {
-				$new_instance = stripslashes_deep($new_instance);
+				$new_instance = wp_unslash($new_instance);
 				$this->_set($number);
 
 				$old_instance = isset($all_instances[$number]) ? $all_instances[$number] : array();
Index: wp-includes/class-wp-customize-setting.php
===================================================================
--- wp-includes/class-wp-customize-setting.php	(revision 23401)
+++ wp-includes/class-wp-customize-setting.php	(working copy)
@@ -144,7 +144,7 @@
 	 * @return mixed Null if an input isn't valid, otherwise the sanitized value.
 	 */
 	public function sanitize( $value ) {
-		$value = stripslashes_deep( $value );
+		$value = wp_unslash( $value );
 		return apply_filters( "customize_sanitize_{$this->id}", $value, $this );
 	}
 
